#include "mbed.h"




I2C i2c(p30,p7);

Serial pc(USBTX,USBRX);



int main(){
    i2c.frequency(1000000);
    char buf[7];
    char test_reading[2];
    char wake_up_reading[2];
    char fifo_status_reading[2];
    char wake_up_packet_reading[6];
    char analog_front_end_reading[2];
    char channel_control_reading[5];
    char fifo_read_active_reading[17];
    char fifo_reset_reading[2];
    char fifo_clear_reading[2];
    
    uint8_t write_addr=0xCA;
    uint8_t read_addr=0xCB;
    
    uint8_t test_addr=0x00;
    uint8_t wake_up_addr=0x22;
    uint8_t fifo_status_addr=0x04;
    uint8_t channel_control_read_addr=0x0e;
    uint8_t channel_control_write_addr=0x10;
    uint8_t analogue_settings_read_addr=0x12;
    uint8_t analogue_settings_write_addr=0x14;
    uint8_t wake_read_addr=0x16;
    uint8_t wake_write_addr=0x18;
    //uint8_t fifo_read_active_addr=0x08;
    uint8_t fifo_read_full_addr=0x06;
    uint8_t fifo_reset_addr=0x0C;
    uint8_t fifo_clear_addr=0x0A;
    
    
    
        i2c.start();
        buf[0]=wake_up_addr;
        i2c.transfer(write_addr,buf,1,wake_up_reading,1,NULL);
        i2c.stop();
        
        wait(0.1);
        
        i2c.start();
        buf[0]=wake_write_addr;
        buf[1]=0xff;
        buf[2]=0xff;
        buf[3]=0x00;
        buf[4]=0x00;
        buf[5]=0x10;
        buf[6]=0x11;
        i2c.write(write_addr,buf,7);
        i2c.stop();
        
        wait(0.1);
        
        i2c.start();
        buf[0]=channel_control_write_addr;
        buf[1]=0x00;
        buf[2]=0xff;
        buf[3]=0xff;
        buf[4]=0x00;
        buf[5]=0x00;
        i2c.write(write_addr,buf,6);
        i2c.stop();
        
        wait(0.1);
        
        i2c.start();
        buf[0]=(channel_control_read_addr);
        i2c.write(write_addr,buf,1,true);
        i2c.read(read_addr,channel_control_reading,5);
        i2c.stop();
        
        wait(0.1);
        
        i2c.start();
        buf[0]=analogue_settings_write_addr;
        buf[1]=0x01;
        buf[2]=0xE1;
        i2c.write(write_addr,buf,3);
        i2c.stop();
        
        wait(0.1);
        
        i2c.start();
        buf[0]=(analogue_settings_read_addr);
        i2c.write(write_addr,buf,1,true);
        i2c.read(read_addr,analog_front_end_reading,2);
        i2c.stop();
        
        wait(0.1);

        
        int i=0;
//        int fifo_count;
//        uint32_t output1;
//        uint32_t output2;
//        float float_output1;
//        float float_output2;
//        float frame_count;
        


 
        while(1){ 
            i2c.start();
            buf[0]=fifo_clear_addr;
            i2c.transfer(write_addr,buf,1,fifo_clear_reading,1,NULL);
            i2c.stop();
            
            wait_us(50);
            
            i2c.start();
            buf[0]=fifo_reset_addr;
            i2c.transfer(write_addr,buf,1,fifo_reset_reading,1,NULL);
            i2c.stop();
            
            wait_us(50);
             
            i2c.start();
            buf[0]=(fifo_read_full_addr);
            i2c.write(write_addr,buf,1,true);
            i2c.read(read_addr,fifo_read_active_reading,17);
            i2c.stop();   
            
            wait_us(50);
            
            i2c.start();
            buf[0]=(wake_read_addr);
            i2c.write(write_addr,buf,1,true);
            i2c.read(read_addr,wake_up_packet_reading,6);
            i2c.stop(); 
            
            wait_us(50);
            
            i2c.start();
            buf[0]=(fifo_status_addr);
            i2c.write(write_addr,buf,1,true);
            i2c.read(read_addr,fifo_status_reading,1);
            i2c.stop(); 
            
            wait_us(50);
            
            i2c.start();
            buf[0]=test_addr;
            i2c.transfer(write_addr,buf,1,test_reading,1,NULL);
            i2c.stop();
            
            wait_us(50);
                       
            pc.printf("fifo clear reading = %X\n\rfifo reset reading = %X\n\rwake up reading = %X\n\r",fifo_clear_reading[0],fifo_reset_reading[0],wake_up_reading[0]);
            pc.printf("analog front end reading[0] = %X\n\ranalog front end reading[1] = %X\n\rchannel_control_reading[0] = %X\n\rchannel_control_reading[1] = %X\n\rchannel_control_reading[2] = %X\n\rchannel_control_reading[3] = %X\n\rchannel_control_reading[4] = %X\n\r",analog_front_end_reading[0],analog_front_end_reading[1],channel_control_reading[0],channel_control_reading[1],channel_control_reading[2],channel_control_reading[3],channel_control_reading[4]);
            pc.printf("wake_up_packet_reading[5] = %X\n\r",wake_up_packet_reading[5]);
            pc.printf("test reading = %X\n\r",test_reading[0]);
            //fifo_count=int((fifo_status_reading[0]&0x1E)>>1);
    
            pc.printf("%i, %i\n\r",int(fifo_status_reading[0]&0x01),int((fifo_status_reading[0]&0x60)>>5));
//            if(fifo_status_reading[0]&0x01==1 /*&& (fifo_status_reading[0]&0x60)>>5==0*/ && i>17){
//                        
//                            uint8_t temp1=(fifo_read_active_reading[3] & 0x7f);
//                            int over_sample1=int((fifo_read_active_reading[3] & 0x80)>>7);
//                            float_output1=float((temp1<<16|fifo_read_active_reading[4]<<8|fifo_read_active_reading[5]));
//                            output1=(fifo_read_active_reading[3]<<16|fifo_read_active_reading[4]<<8|fifo_read_active_reading[5]);
//                            
//                            uint8_t temp2=(fifo_read_active_reading[6] & 0x7f);
//                            int over_sample2=int((fifo_read_active_reading[6] & 0x80)>>7);
//                            float_output2=float((temp2<<16|fifo_read_active_reading[7]<<8|fifo_read_active_reading[8]));
//                            output2=(fifo_read_active_reading[6]<<16|fifo_read_active_reading[7]<<8|fifo_read_active_reading[8]);
//                            
//                            pc.printf("%i,%f,%f,%X,%X,%X,%X,%X\n\r",i,float_output1,float_output2,output1,output2,fifo_status_reading[0],over_sample1,over_sample2);
//                        
//               }
            i++;
    
        
            }
    
    
}
    
    
    
